#version 420

uniform sampler2D diffuseTexture;
uniform vec4 lightColor;
uniform float alphaDiscardFactor;
uniform unsigned int useLightIntensity;

in vec2 uv;

out vec4 out_color;

void main()
{
	vec4 color = vec4(1.0f,1.0f,1.0f,1.0f);
	color = texture(diffuseTexture, uv);
	if(color.a < alphaDiscardFactor) { discard; }  
	if (useLightIntensity == 1)	{ out_color = color * vec4(lightColor.rgb * lightColor.a, 1.0); }
	else						{ out_color = color * vec4(lightColor.rgb, lightColor.a); }
}