#version 420

uniform sampler2D matrixTexture;
uniform sampler2D matrixGlowTexture;
//uniform sampler2D fireBodyTexture;

uniform sampler2D fireTexture0;
uniform sampler2D fireTexture1;
uniform sampler2D fireTexture2;
uniform sampler2D fireTexture3;
uniform sampler2D fireTexture4;
uniform sampler2D fireTexture5;
uniform sampler2D fireTexture6;
uniform sampler2D fireTexture7;
uniform sampler2D fireTexture8;
uniform sampler2D fireTexture9;

uniform unsigned int matrixMode;
uniform float matrixScale;
uniform vec2 matrixGlowOffset;
uniform float matrixGlowAmount;
uniform unsigned int birdMode;
uniform unsigned int shadowMode;

//uniform float ambientCoefficient;
//uniform float diffuseCoefficient;
//uniform float specularCoefficient;
//uniform float specularHardness;

in vec3 position;
in vec3 normal;
in vec2 uv;
flat in vec3 corridordirection;
flat in unsigned int tex;

out vec4[1] out_color;

void main()
{
	if (shadowMode == 1) 
	{ 	
		out_color[0] = vec4(gl_FragCoord.z,gl_FragCoord.z, gl_FragCoord.z, 1.0); 
	}
	else
	{
		vec4 color = vec4(0.0f,0.0f,0.0f,1.0f);
		vec2 uvs = uv;

		if(matrixMode == 0) 
		{
			if (birdMode == 1) //firebird
			{
				if (tex == 0) //birdbody
				{
					//uvs = vec2(uv.y,uv.x);
					uvs.x *= 2.0f;
					//color = texture(fireBodyTexture, uv - matrixGlowOffset);	
				}

				if		(corridordirection.x < 0.1f)	{ 	color = texture(fireTexture0, uvs); }
				else if (corridordirection.x < 0.2f)	{	color = texture(fireTexture1, uvs); }
				else if (corridordirection.x < 0.3f)	{	color = texture(fireTexture2, uvs); }
				else if (corridordirection.x < 0.4f)	{	color = texture(fireTexture3, uvs); }
				else if (corridordirection.x < 0.5f)	{	color = texture(fireTexture4, uvs); }
				else if (corridordirection.x < 0.6f)	{	color = texture(fireTexture5, uvs); }
				else if (corridordirection.x < 0.7f)	{	color = texture(fireTexture6, uvs); }
				else if (corridordirection.x < 0.8f)	{	color = texture(fireTexture7, uvs); }
				else if (corridordirection.x < 0.9f)	{	color = texture(fireTexture8, uvs); }
				else									{	color = texture(fireTexture9, uvs); }
				if (tex == 1) { if (color.a <= 0.1) { discard; }  }
				else if (tex == 0)
				{
						color *= vec4(color.a,color.a,color.a,0.0f);
						color.a = 1.0f;
				}
			}
			else if (birdMode == 2) //holybird
			{
				color = vec4(1.0f, 1.0f, 1.0f, 1.0f);
			}
		}
		else
		{
			color = texture(matrixTexture,uv * matrixScale);

			float glow = texture(matrixGlowTexture, uv * matrixScale + matrixGlowOffset).r;

			if(glow > 0.0f)
			{
				color *= matrixGlowAmount;
			}
		}

		//out_color[0] = vec4(position, 1.0f /* - tex*/);
		out_color[0] = color;
		//out_color[1] = vec4 (color.xy, color.a, 1.0f);//vec4(/*ambientCoefficient + diffuseCoefficient + specularCoefficient - specularHardness*/ 1.0f, 1.0f, 1.0f, 0.0f);
		//out_color[3] = vec4(normal,0.0f);
	}
}