#version 420
   
in vec4 position;
in vec3 direction;
in float wingposition;
in vec3 corridordirection;

out VertexData {
	vec3 position;
	mat4 rotationMatrix;
	float wingposition;
	vec3 corridordirection;
} VertexOut;

mat4 rotateX(float vertAngle)
{
	float sinus = sin(vertAngle);
	float cosinus = cos(vertAngle);
	return mat4(1.0f,0.0f,0.0f,0.0f,	0.0f,cosinus,sinus,0.0f,	0.0f,-sinus,cosinus,0.0f,	0.0f,0.0f,0.0f,1.0f);
}

mat4 rotateY(float horAngle)
{
	float sinus = sin(horAngle);
	float cosinus = cos(horAngle);
	return mat4(cosinus,0.0f,-sinus,0.0f,	0.0f,1.0f,0.0f,0.0f,	sinus,0.0f,cosinus,0.0f,	0.0f,0.0f,0.0f,1.0f);
}

mat4 getRotationMatrix()
{
	vec3 directionsource = normalize(direction);
	vec3 directiony;
	float horAngle, vertAngle;
	if (abs(directionsource.y) >= 0.999) //Special case, the direction points completely down- or upwards
	{ 
		vertAngle = 1.57079f; //pi/2 = 90 degrees
		horAngle = 0.0f;
	}
	else 
	{
		vec3 directiony = normalize(vec3(directionsource.x, 0.0f, directionsource.z)); 
		vec3 directionreference = vec3(0.0f,0.0f,-1.0f);
		horAngle = acos(dot(directiony,directionreference));
		vertAngle = acos(dot(directiony,directionsource));
	}

	if (directionsource.x > 0) { horAngle *= -1; }
	if (directionsource.y < 0) { vertAngle *= -1; }

	return rotateY(horAngle) * rotateX(vertAngle);
} 

void main()
{
	gl_Position = vec4(position.xyz, 1.0f);
	VertexOut.position = position.xyz;
	VertexOut.rotationMatrix = getRotationMatrix();
	VertexOut.wingposition = wingposition;
	if (VertexOut.wingposition > 0) { VertexOut.wingposition -= 10.0f;}
	else { VertexOut.wingposition = (VertexOut.wingposition + 10.0f) * -1.0f; }
	VertexOut.corridordirection = corridordirection;
}