#version 400

uniform sampler2D inputTexture;

uniform unsigned int kernelSteps;
uniform float stepWidth;
uniform vec2 stepDirection;

in vec2 vuv;

out vec4 out_color;

float coeff[4] = float[4](0.39894228f,0.241970725f,0.053990967f,0.004431848f);

void main()
{
	vec4 color = texture(inputTexture, vuv) * coeff[0];
	float sum = coeff[0];

	vec2 steps = stepDirection * stepWidth;

	for(unsigned int i=1; i<=kernelSteps; i++)
	{
		color += texture(inputTexture, vuv + steps * i) * coeff[i];
		color += texture(inputTexture, vuv - steps * i) * coeff[i];
		sum += coeff[i] * 2.0f;
	}

	out_color = color / sum;
}