#version 400

uniform sampler2D diffuseTexture;
uniform vec3 lightPos;

in vec3 vposition;
in vec3 vnormal;
in vec2 vuv;

out vec4 out_color;

void main()
{
	vec4 diffuseColor = texture(diffuseTexture, vuv);

	vec3 lightDir = normalize(lightPos - vposition);
	float NdL = clamp(dot(normalize(vnormal), lightDir), 0.0f, 1.0f);

	diffuseColor.rgb *= NdL;
	out_color = diffuseColor;
}