#version 400

uniform mat4 vpMatrix;
uniform mat4 modelMatrix;
uniform unsigned int isLeaf,instance;
uniform float time;
uniform float windinfluence;

in vec3 position;
in vec3 normal;
in vec2 uv;
in vec3 tangent;
in vec3 bitangent;

out vec3 vposition;
out vec3 vnormal;
out vec2 vuv;
out mat3 texSpaceMat;

void main()
{
	vec4 offset = vec4(0.0f,0.0f,0.0f,0.0f);
	
	if(gl_VertexID % 2 == 0)
	{
		if(isLeaf != 0)
		{
			offset = vec4(cos(3.14159 * time + (3.14159 * (instance/61.0f))) * windinfluence * 1.5f,sin(time * 3.14159 * (((gl_VertexID % 10)+1) * 0.1f)) * windinfluence,sin(3.14159 * time * 0.5f + (3.14159 * (instance/61.0f))) * windinfluence * 1.5f,0.0f);
		}
	}

	vec4 pos = modelMatrix * vec4(position,1.0f) + offset;
	gl_Position = vpMatrix * pos;
	vposition = pos.xyz;

	mat3 rotMat = mat3(modelMatrix);
	vnormal = normalize(rotMat * normal);
	
	vec3 rtangent = normalize(rotMat * tangent);
	vec3 rbitangent = normalize(rotMat * bitangent);

	texSpaceMat = mat3(rtangent, rbitangent, vnormal);

	vuv = uv;
}