#version 400

uniform sampler2D diffuseTexture;
uniform sampler2D normalTexture;

in vec3 vlightDir;
in vec3 vviewDir;
in vec2 vuv;

out vec4 out_color;

void main()
{
	vec4 diffuseColor = texture(diffuseTexture, vuv);
	vec3 normal = (texture(normalTexture, vuv).xyz - 0.5f) * 2.0f;

	float NdL = clamp(dot(normal, vlightDir), 0.0f, 1.0f);

	vec3 hv = normalize((vlightDir + vviewDir) / 2.0f);
	float NdH = clamp(dot(normal, hv),0.0f,1.0f);

	vec4 specularColor = vec4(diffuseColor.rgb * NdH,1.0f);
	diffuseColor.rgb *= NdL;
	out_color = diffuseColor * 0.8f + specularColor * 0.5;
}