#version 400

uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelMatrix;
uniform vec3 lightPos;
uniform vec3 camPos;

in vec3 position;
in vec3 normal;
in vec4 uv;
in vec3 tangent;
in vec3 bitangent;

out vec3 vlightDir;
out vec3 vviewDir;
out vec2 vuv;

void main()
{
	gl_Position = modelViewProjectionMatrix * vec4(position,1.0f);
	vec3 vposition = (modelMatrix * vec4(position,1.0f)).xyz;
	
	vec3 lightDir = normalize(lightPos - vposition);
	vec3 viewDir = normalize(camPos - vposition);

	vec3 vnormal = normalize(mat3(modelMatrix) * normal);
	vec3 vtangent = normalize(mat3(modelMatrix) * tangent);
	vec3 vbitangent = normalize(mat3(modelMatrix) * bitangent);
	
	mat3 transmat = transpose(mat3(vtangent, vbitangent, vnormal));

	vlightDir = normalize(transmat * lightDir);
	vviewDir = normalize(transmat * viewDir);

	vuv = uv.zw * 16.0f;
}