#version 400

uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelMatrix;
uniform vec2 matrixGlowOffset;

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 vposition;
out vec3 vnormal;
out vec2 vuv;
out vec2 vuvBump;

void main()
{
	gl_Position = modelViewProjectionMatrix * vec4(position,1.0f);

	vposition = (modelMatrix * vec4(position,1.0f)).xyz;
	vnormal = mat3(modelMatrix) * -normal;
	vuv = uv;
	vuvBump = uv/0.2f + matrixGlowOffset / 5.0f;
}