#version 330

out vec4[4] vFragColor;

uniform samplerCube cubeMap;
uniform sampler2D matrixTexture;
uniform sampler2D matrixGlowTexture;
uniform unsigned int matrixMode;
uniform float matrixScale;
uniform vec2 matrixGlowOffset;
uniform float matrixGlowAmount;

in vec3 vVaryingTexCoord;
in vec2 vuv;
in vec3 vposition;

void main(void)
{
	vec4 tex;
	if(matrixMode == uint(0))
	{
		tex = texture(cubeMap, vVaryingTexCoord);
	}
	else
	{
		tex = texture(matrixTexture, vuv * matrixScale);

		float glow = texture(matrixGlowTexture, vuv * matrixScale + matrixGlowOffset).r;

		if(glow > 0.0f)
		{
			tex *= matrixGlowAmount;
		}
	}

	vFragColor[0] = vec4(0.0f,0.0f,0.0f,1.0f);
	vFragColor[1] = vec4(tex.rgb,0.0f);
	vFragColor[2] = vec4(0.0f,0.0f,0.0f,0.0f);
	vFragColor[3] = vec4(0.0f,0.0f,0.0f,0.0f);
}